/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._tcp_echo_thread_pool;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.util.Scanner;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.RejectedExecutionException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class TCPServerConcorrente implements Runnable
{
    private ServerSocket serverSocket;
    private ExecutorService threads;
    private final int N_MAX_THREADS=3;  //massimo numeor di thread cintemporaneamente in esecuzione
    
    public TCPServerConcorrente(int port) throws IOException
    {
        serverSocket=new ServerSocket(port);
        serverSocket.setSoTimeout(1000);
        threads =Executors.newFixedThreadPool(N_MAX_THREADS);  //thread pool "gestore di thread"
    }

    @Override
    public void run() 
    {
        
            while(!Thread.interrupted())
            {
                try 
                {
                    Socket connection=serverSocket.accept();
                    ClientThread clientConnection=new ClientThread(connection);
                    Thread clientThread=new Thread(clientConnection);
                    //clientThread.start();
                    try
                    {
                        threads.submit(clientThread);
                    }
                     catch(RejectedExecutionException ex)
                    {
                        connection.close(); //chiudo il socket poichè il thread pool non è in esecuzione
                        System.out.println("Impossibile avviare il thread. Thread pool chiuso");
                    }
                    
                } 
               
                catch (SocketTimeoutException ex) 
                {
                    System.out.println("Timeout");
                }
                catch (IOException ex) 
                {
                    System.out.println("Errore di comunicazione");
                }
            }
        try 
        {
            serverSocket.close();
            threads.shutdown(); //arresto il thread pool;
            System.out.println("Server interrotto");
        }
        catch (IOException ex) 
        {
            System.out.println("Errore nella chiusura del server");
        }
            
    }
    
    public static void main(String[] args) 
    {
        Scanner tastiera=new Scanner(System.in);
        try 
        {
            TCPServerConcorrente tcpServerConcorrente=new TCPServerConcorrente(7);
            Thread threadServerConcorrente=new Thread(tcpServerConcorrente);
            threadServerConcorrente.start();
            tastiera.nextLine();
            threadServerConcorrente.interrupt();
        } 
        catch (IOException ex) 
        {
            System.out.println("Impossibile avviare il server");
        }
    }
    
}
