/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._tcp_calcolatrice_thread_pool;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class ClientThread implements Runnable
{
    private Socket connection;
    private InputStream input;
    private OutputStream output;
    
    public ClientThread(Socket connection) throws IOException
    {
        this.connection=connection;
        input=connection.getInputStream();
        output=connection.getOutputStream();
    }
    
    @Override
    public void run() 
    {
        int n;
        byte[] buffer=new byte[1024];
        String answer="";
        String requestMessage="";
        try 
        {
            while((n=input.read(buffer))!=-1)
            {
                if (n>0)  //se sono arrivati dei byte
                {
                    String frag=new String(buffer,0,n,"UTF-8");
                    requestMessage+=frag;   //ricostruisco il messaggio ricevuto
                    if ((char)buffer[n-1]==10 || (char)buffer[n-1]==13)  //se l'ultimo carattere arrivato è \n o\r
                    {
                        answer=calcolo(requestMessage.getBytes());
                        output.write(answer.getBytes("UTF-8"));
                        output.flush();
                        break;
                    }          
                } 
            }
        } 
        catch (IOException ex) 
        {
            System.out.println("Errore di comunicazione");
        }   
        try 
        {
            connection.shutdownInput();
            connection.shutdownOutput();
            connection.close();
            System.out.println("Connnessione chiusa");
        } 
        catch (IOException ex) 
        {
            System.out.println("Errore durante la chiusura della connessione");
        }
    }  
    
    String calcolo(byte[] requestData) throws UnsupportedEncodingException
    {
        String requestMessage=new String(requestData,"UTF-8");
        String[] requestElements;
        double x,y,risultato;
        String operazione;
        String responseMessage;
        
        
        requestElements=requestMessage.split(",");
        operazione=requestElements[0];
        x=Double.parseDouble(requestElements[1]);
        y=Double.parseDouble(requestElements[2]);
        
        switch (operazione) {
            case "ADD":
                risultato=x+y;
                break;
            case "SUB":
                risultato=x-y;
                break;
            case "MUL":
                risultato=x*y;
                break;
            case "DIV":
                if (y==0)
                    return "divisione per 0";
                else
                    risultato=x/y;
                break;
            default:
                return "ERROR";
        }
        responseMessage=Double.toString(risultato);
        responseMessage+="\r\n";
        return responseMessage;
    }
    
}
