/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._tcp_calcolatrice_thread_pool;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class TCPClient 
{
    private Socket clientSocket;
    
    public TCPClient() throws SocketException
    {
        clientSocket=new Socket();
        clientSocket.setSoTimeout(1000);
    }
    
    public String sendAndReceive(String requestMessage,String ipServer, int port) throws UnknownHostException, IOException, SocketTimeoutException
    {
        InputStream inputStream;
        OutputStream output;
        byte[] buffer=new byte[1024];
        int n;
        String answer="";
        
        InetSocketAddress server=new InetSocketAddress(InetAddress.getByName(ipServer), port);
        clientSocket.connect(server,1000); //Timeout quando tenta la connessione
        
        //Istanzio l'outputStream per inviare la request
        output=clientSocket.getOutputStream();
        output.write(requestMessage.getBytes("UTF-8"));
        output.flush();
        inputStream=clientSocket.getInputStream();
        
         while((n=inputStream.read(buffer))!=-1)
        {
            String frag=new String(buffer,0,n,"UTF-8");
            answer+=frag;
        }
        clientSocket.shutdownInput();
        clientSocket.close();
        return answer;    
    }
    
    public static void main(String[] args) 
    {
        String ipServer="127.0.0.1";
        int port=2000;
        String answer;
        String requestMessage="";
        Scanner tastiera=new Scanner(System.in);
        if (args.length==1)
            requestMessage=args[0]+"\r\n"; 
        else
             requestMessage="ADD,3,2\n\r";
        //Oppure far inserire il comando all'utente
        //Aggiungere dei controlli sull'input
        try 
        {
           TCPClient tcpClient=new TCPClient();
           answer= tcpClient.sendAndReceive(requestMessage,ipServer, port);
           System.out.println("Risposta del server --> "+answer);
           tastiera.nextLine();
         
        } 
        catch (SocketException ex) 
        {
            System.out.println("Impossibile aprire il socket");
        }
        catch (UnknownHostException ex)
        {
            System.out.println("Ip server sconosciuto");
        }
        catch (SocketTimeoutException ex)
         {
             System.out.println("Il server non risponde");
         }
        catch (IOException ex)
        {
            System.out.println("Errore di comunicazione");
        }
        
    }
    
}
