/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._es_18_tcp_magazzino;

import gestioneFile.FileException;
import gestioneFile.TextFile;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.net.Socket;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class ClientThread implements Runnable
{
    private Socket connection;
    private InputStream input;
    private OutputStream output;
    private ArrayList<Prodotto> elencoProdotti;
    private String nomefile="elencoProdotti.csv";
    
    public ClientThread(Socket connection) throws IOException
    {
        this.connection=connection;
        input=connection.getInputStream();
        output=connection.getOutputStream();
    }
    
    @Override
    public void run() 
    {
        int n;  
        byte[] buffer=new byte[1024];
        String answer="";
        String requestMessage="";
        try 
        {
            while((n=input.read(buffer))!=-1)
            {
                if (n>0)  //se sono arrivati dei byte
                {
                    String frag=new String(buffer,0,n,"UTF-8");
                    requestMessage+=frag;   //ricostruisco il messaggio ricevuto
                    if ((char)buffer[n-1]==10 || (char)buffer[n-1]==13)  //se l'ultimo carattere arrivato è \n o\r
                    {
                        answer=gestioneMessaggio(requestMessage.getBytes());
                        output.write(answer.getBytes("UTF-8"));
                        output.flush();
                        break;
                    }          
                } 
            }
        } 
        catch (IOException ex) 
        {
            System.out.println("Errore di comunicazione");
        }   
        try 
        {
            connection.shutdownInput();
            connection.shutdownOutput();
            connection.close();
            System.out.println("Connnessione chiusa");
        } 
        catch (IOException ex) 
        {
            System.out.println("Errore durante la chiusura della connessione");
        }
    }  
    
    String gestioneMessaggio(byte[] requestData) throws UnsupportedEncodingException
    {
        String requestMessage=new String(requestData,"UTF-8");
        String[] requestElements;
        double x,y,risultato;
        String operazione;
        String responseMessage;
        
        
        requestElements=requestMessage.split(";");
        if (requestElements.length==2)
        {
            responseMessage=cercaProdotto(requestElements[0]);
        }
        else if (requestElements.length==3)
        {
           responseMessage=aggiornaQuantitaProdotto(requestElements[0],requestElements[1]);  
        }
        else
            responseMessage="ERROR";
                
        responseMessage+="\r\n";
        return responseMessage;
    }
    
    private void caricaProdottiinArray() throws IOException
    {
        elencoProdotti=new ArrayList<Prodotto>();
        TextFile file=new TextFile(nomefile, 'R');
        String stringaProdotto;
        String[] datiProdotto;
        Prodotto p;
        do
        {
            try 
            {
                stringaProdotto=file.fromFile();
                datiProdotto=stringaProdotto.split(";");
                p=new Prodotto(Integer.parseInt(datiProdotto[0]), datiProdotto[1],Integer.parseInt(datiProdotto[2]));
                elencoProdotti.add(p);
            } 
            catch (FileException ex) 
            {
                //fine del file i file aperto in scrittura
                file.close();
                break;
            }
        }while (true);  
    }
    
    private String cercaProdotto(String codice)
    {
        try 
        {
            caricaProdottiinArray();
        } 
        catch (IOException ex) 
        {
            return "ERROR"; //impossibile leggere dal file
        }
        String responseMessage;
        for(Prodotto p:elencoProdotti)
        {
            if (Integer.toString(p.getCodice()).equals(codice))
            {
                responseMessage=Integer.toString(p.getCodice())+";"+Integer.toString(p.getQuantita());
                return responseMessage;
            }
        }
        return "ERROR"; //prodotto non trovato
    }
    
     private String aggiornaQuantitaProdotto(String codice, String quantita)
    {
        try 
        {
            caricaProdottiinArray();
        } 
        catch (IOException ex) 
        {
            return "ERROR"; //impossibile leggere dal file
        }
        String responseMessage;
        int posizioneProdotto;
        for(Prodotto p:elencoProdotti)
        {
            if (Integer.toString(p.getCodice()).equals(codice))
            {
                posizioneProdotto=elencoProdotti.indexOf(p);
                p.setQuantita(Integer.parseInt(quantita));
                elencoProdotti.remove(posizioneProdotto);
                elencoProdotti.add(p);
                try 
                {
                    salvaArraySuFile();
                } catch (IOException | FileException ex) 
                {
                    responseMessage="ERROR"; //impossibile scrivere su file
                    return responseMessage;
                } 
               responseMessage="OK";
                return responseMessage;
            }
        }
        return "ERROR"; //prodotto non trovato
    }
   
     private void  salvaArraySuFile() throws IOException, FileException
    {
        TextFile file=new TextFile(nomefile, 'W');
        for(Prodotto p:elencoProdotti)
            file.toFile(Integer.toString(p.getCodice())+";"+p.getDescrizione()+";"+Integer.toString(p.getQuantita()));
        file.close();
    }
}

