/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._echo_udp;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class UDPClient 
{
    private DatagramSocket socket;
    private final int MAX_LENGHT_DATA=1024; 
    
    public UDPClient() throws SocketException
    {
        socket=new DatagramSocket();
        socket.setSoTimeout(1000);
    }
    
    public String sendAndReceive (String messagge, String host, int port) throws UnknownHostException, UnsupportedEncodingException, SocketTimeoutException, IOException
    {
        byte[] requestBuffer;
        byte[] responseBuffer=new byte[MAX_LENGHT_DATA];
        String responseMessage= "ERROR";    //default
        DatagramPacket response=new DatagramPacket(responseBuffer, responseBuffer.length);
        InetAddress serverAddress=InetAddress.getByName(host);
        //trasformo la stringa da inviare in array di byte
        requestBuffer=messagge.getBytes("UTF-8"); 
        //costruisco il pacchetto "request"
        DatagramPacket request=new DatagramPacket(requestBuffer, requestBuffer.length, serverAddress, port);
        //spedisco la request al server
        socket.send(request);
        //attendo la risposta da parte del server
        // se non arriva entro 1 sec si verifica la SocketTimeoutException (passata al chiamante)
        socket.receive(response);
        //Se arriva la risposta, verifichiamo che il mittente sia server ed estraiamo il messaggio ricevuto
        
        if (response.getAddress().equals(serverAddress) && response.getPort()==port)
        {
            responseMessage=new String(response.getData(), "UTF-8");
            //"Ripulisco" la stringa dai caratteri in eccesso rispetto a quelli previsti nella response
            responseMessage=responseMessage.substring(0, response.getLength());
        }
        return responseMessage;     
    }
    
    public void close_socket()
    {
        socket.close();
    }
    
    public static void main(String[] args) 
    {
        String message="pane";
        String ipServer="127.0.0.1";
        int serverPort=7;
        Scanner tastiera=new Scanner(System.in);
        
        if (args.length==1)
        {
            message=args[0];
        }
        
        
        UDPClient client = null;
        String responseMessage;
        try 
        {
            client=new UDPClient();
            responseMessage=client.sendAndReceive(message, ipServer, serverPort);
            System.out.println("Risposta del server --> "+responseMessage);
        } 
        catch (SocketException ex) 
        {
            System.out.println("Impossibile istanziare il socket sel server");
        } 
        catch (UnsupportedEncodingException ex) 
        {
             System.out.println("Il messaggio contiene caratteri non validi");
        } 
        catch (SocketTimeoutException ex) 
        {
             System.out.println("Il server non risponde");
        } 
        catch (IOException ex) 
        {
             System.out.println("Errore di comunicazione");
        }
        
        tastiera.nextLine();
        client.close_socket();
        
    }
}
