/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._protocollo_ciao_lao;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.util.Scanner;
import java.util.concurrent.TimeoutException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class UDPClient 
{    private DatagramSocket socket;    
    public UDPClient() throws SocketException
    {
        socket=new DatagramSocket();
        socket.setSoTimeout(1000);
    }
    
    public String sendAndReceive(String message, String serverAddress, int port) throws UnknownHostException, UnsupportedEncodingException, TimeoutException, IOException
    {
        byte[] buffer;
        byte[] bufferAnswer=new byte[8192];
        InetAddress ipAddress=InetAddress.getByName(serverAddress);
        String answer;
        
        buffer=message.getBytes("UTF-8");
        DatagramPacket datagram=new DatagramPacket(buffer, buffer.length, ipAddress, port);
        DatagramPacket datagramAnswer=new DatagramPacket(bufferAnswer, bufferAnswer.length, ipAddress, port);
        socket.send(datagram);
        socket.receive(datagramAnswer);
        answer=new String(datagramAnswer.getData(),"UTF-8");
        answer=answer.substring(0,datagramAnswer.getLength());
        return answer;
    }
    
    public void close()
    {
        socket.close();
    }
    
    public static void main(String[] args) 
    {
        String message="lao";
        String ipAddress="192.168.181.7";
        int port=7;
        
        Scanner tastiera=new Scanner(System.in);
        
        if(args.length==3)
        {
            message=args[0];
            ipAddress=args[1];
            port=Integer.parseInt(args[2]);
        }
        
       
        try 
        {
            String answer;
            UDPClient echoCient=new UDPClient();
            answer= echoCient.sendAndReceive(message, ipAddress, port);
            echoCient.close();
            System.out.println("Messaggio ricevuto: "+answer);
            tastiera.nextLine();
        } 
        catch (SocketException ex) 
        {
            System.out.println("Impossibile aprire il socket");
        } 
        catch (UnsupportedEncodingException ex) 
        {
            System.out.println("Errore nella codifica del messaggio");        
        } 
        catch(TimeoutException e)
        {
             System.out.println("Errore nella codifica del messaggio");    
        }
        catch (IOException ex) 
        {
            System.out.println("Errore di I/O");
        }
    }
}
