/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._datetimeudp;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class UDPClient 
{
    private DatagramSocket socket;
    
    public UDPClient() throws SocketException
    {
        socket=new DatagramSocket();
        socket.setSoTimeout(1000);
    }
    
    public String sendAndReceive(String requestMessage,String serverAddress,int port) throws UnsupportedEncodingException, SocketTimeoutException, UnknownHostException, IOException
    {
        byte[] requestBuffer;
        byte[] responseBuffer=new byte[8192];
        DatagramPacket request;
        DatagramPacket response;
        InetAddress ipAddress=InetAddress.getByName(serverAddress);
        String responseMessage = null;
        
        
        requestBuffer=requestMessage.getBytes("UTF-8");
        request=new DatagramPacket(requestBuffer, requestBuffer.length,ipAddress, port);
        socket.send(request);
        
        //attendo la risposta
        response=new DatagramPacket(responseBuffer, responseBuffer.length); //Pacchetto vuoto con 8192 byte di dati
        socket.receive(response);
        if (response.getAddress().equals(ipAddress) && response.getPort()==port)
        {
             responseMessage=new String(response.getData(), "UTF-8");
             responseMessage=responseMessage.substring(0,response.getLength()); //"Taglio la risposta" togliendo i byte vuoti
        }
        return responseMessage;
    }
    
    public void close()
    {
       socket.close();
    }
    
    public static void main(String[] args) 
    {
        String message="Hello World";
        String serverAddress="127.0.0.1";
        int serverPort=7;
        String responseMessage;
        
        
        try
        {
            UDPClient echoClient = new UDPClient();
            responseMessage=echoClient.sendAndReceive(message, serverAddress, serverPort);
            echoClient.close();
            
            System.out.println("Risposta del server --> "+responseMessage);
            
        } 
        catch (SocketException ex) 
        {
            System.out.println("Impossibile aprire il socket");
        } 
        catch (UnknownHostException ex) 
        {
            System.out.println("Impossibile raggiungere il server");        
        } 
         catch (SocketTimeoutException ex) 
        {
            System.out.println("Il server non risponde");        
        } 
        catch (IOException ex) 
        {
            System.out.println("Errore di comunicazione");
        }
    }
}


