/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._datetimeudp;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.time.LocalDateTime;
import java.util.Scanner;
import java.util.concurrent.TimeoutException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class UDPServer implements Runnable
{
    private DatagramSocket socket;
    
    public UDPServer(int port) throws SocketException
    {
        socket=new DatagramSocket(port);
        socket.setSoTimeout(1000);
    }

    @Override
    public void run()
    {
        byte[] requestBuffer=new byte[8192];
        byte[] responseBuffer;
        DatagramPacket request=new DatagramPacket(requestBuffer, requestBuffer.length);
        DatagramPacket response;
        String messageDataOra;
        
        while(!Thread.interrupted())
        {
            try 
            {
                socket.receive(request);
                messageDataOra=LocalDateTime.now().toString();
                responseBuffer=messageDataOra.getBytes("UTF-8");
                response=new DatagramPacket(responseBuffer, responseBuffer.length, request.getAddress(),request.getPort());
                socket.send(response);
            } 
            catch (SocketTimeoutException ex) 
            {
                System.out.println("Timeout");
            }
            catch (IOException ex) 
            {
                System.out.println("Errore di comunicazione");
            }
        }
        socket.close();
        System.out.println("Il server è stato disconnesso");
    }
    
    public static void main(String[] args) 
    {
        Thread serverThread;
        Scanner tastiera= new Scanner(System.in);
        
        
        try 
        {
            UDPServer echoServer=new UDPServer(7);
            serverThread=new Thread(echoServer);
            serverThread.start();
            tastiera.nextLine();
            serverThread.interrupt();
            
        } 
        catch (SocketException ex) 
        {
            System.out.println("Impossibile aprire il socket");
        }
    }
    
    
}
