/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._calcolatrice_udp;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class UDPClient 
{
    private DatagramSocket socket;
    
    public UDPClient() throws SocketException
    {
        //Istanzio il socket del client e 
        //assegno un Timeout di 1 s
        socket=new DatagramSocket();
        socket.setSoTimeout(1000);
    }
    
    public String sendAndReceive(String message, String host, int port) throws SocketTimeoutException,UnknownHostException, UnsupportedEncodingException, IOException
    {
        DatagramPacket request;
        DatagramPacket response;
        byte[] responseData=new byte[8192];
        String responseMessage;
        
        InetAddress ipAddress=InetAddress.getByName(host);
        request=new DatagramPacket(message.getBytes("UTF-8"), message.length(),ipAddress,port);
        response=new DatagramPacket(responseData, responseData.length);
        socket.send(request);
        socket.receive(response);
        
        if (response.getAddress().equals(ipAddress) && response.getPort()==port)
        {
            responseMessage=new String(response.getData(),"UTF-8");
            //"taglio la risposta ai soli caratteri utili
            responseMessage=responseMessage.substring(0,response.getLength());
        }
        else
        {
            responseMessage="Error!";
        }
        
        
        return responseMessage;
    }
    
    public void close()
    {
        socket.close();
    }
    
    public static void main(String[] args) 
    {
        String ipServer="127.0.0.1";
        int port=7;
        String message="DIV,3,92";
        
        /*
            IL MESSAGGIO PUO' ESSERE FATTO INSERIRE COME DATO DI INPUT DALL'UTENTE
        */
        
        
        UDPClient echoClient = null;
        
        String serverAnswer;
        
        try 
        {
            echoClient=new UDPClient();
            serverAnswer=echoClient.sendAndReceive(message, ipServer, port);
            System.out.println("Risposta del server --> "+serverAnswer);
        } 
        catch (SocketException ex) 
        {
            System.out.println("Impossibile aprire il socket del client");
        } 
        catch (UnknownHostException ex) 
        {
             System.out.println("Host non raggiungibile");
        } 
        catch (UnsupportedEncodingException ex) 
        {
             System.out.println("Messaggio non corretto");
        } 
        catch (SocketTimeoutException ex) 
        {
           System.out.println("Il server non risponde");
        }
        catch (IOException ex) 
        {
           System.out.println("Errore di comunicazione");
        }
        
        echoClient.close();
    }
}
