/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._tcp_datetime;

import java.io.IOException;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketTimeoutException;
import java.time.LocalDateTime;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class TCPServer implements Runnable
{
    private ServerSocket server;    //socket del server che attende la richiesta di connessione

    public TCPServer(int port) throws IOException 
    {
        server=new ServerSocket(port);
        server.setSoTimeout(1000);
        
    }
    
    public void run()
    {
        //Socket del server generato dalla richiesta di connessione
        Socket connection = null;              
        byte[] outputBuffer=new byte[8192];
        
        while(!Thread.interrupted())
        {
            try
            {
                connection=server.accept();
                //se arriva la richiesta, istanzio un output stream (di byte)
                //porei istanziare un outputStreamWriter
                OutputStream out=connection.getOutputStream();
                String adesso=LocalDateTime.now().toString();
                outputBuffer=adesso.getBytes("UTF-8");
                out.write(outputBuffer);
                out.flush();
                System.out.println("Risposta inviata");
                connection.shutdownOutput();
                connection.close();
            } 
            catch (SocketTimeoutException ex) 
            {
                System.out.println("Timeout");
            }
            catch (IOException ex) 
            {
                System.out.println("Errore di connessione");
            }
            finally
            {
                if (connection!=null && !connection.isClosed())
                {
                    try 
                    {
                        connection.close();
                    } 
                    catch (IOException ex)
                    {
                        System.out.println("Errore nella chiusura del socket");
                    }
                }
            }
        } 
        //Chiudo il serverSocket quando il ciclo viene interrotto
        try 
        {
            server.close();
        } 
        catch (IOException ex) 
        {
            System.out.println("Errore nella chiusura del socket");
        }
    }
    
    
    
    public static void main(String[] args) 
    {
        Scanner tastiera=new Scanner(System.in);
        
        try 
        {
           
            TCPServer server=new TCPServer(13);
            Thread serverThread=new Thread(server);
            serverThread.start();
            tastiera.nextLine();
            serverThread.interrupt();
            serverThread.join();
            System.out.println("Server interrotto");
        } 
        catch (IOException ex) 
        {
            System.out.println("Impossibile avviare il server");
        } 
        catch (InterruptedException ex) 
        {
            System.out.println("Impossibile interrompere il server");
        }
    }
    
}


