/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._tcp_concorrente_echo;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketTimeoutException;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class TCPServerConcorrente implements Runnable
{
    private ServerSocket server;
    
    public TCPServerConcorrente(int port) throws IOException
    {
        server=new ServerSocket(port);
        server.setSoTimeout(1000);
    }
    
    public void run()
    {
        Socket connection;
        while(!Thread.interrupted())
        {
            try 
            {
                connection=server.accept();
                //Se arriva la richiesta di connessione
                //istanzio un ClientThread
                System.out.println("Connessione richiesta da "+connection.getInetAddress().toString()+"/"+connection.getPort());
                ClientThread clientThread=new ClientThread(connection);
                Thread clientConnection=new Thread(clientThread);
                clientConnection.start();
            } 
            
            catch (SocketTimeoutException ex) 
            {
                System.out.println("Timeout");
            }
            catch (IOException ex) 
            {
                System.out.println("Errore di comunicazione");
            }
        }
        
        //Chiusura del server. Il server non accetterà nuove connessioni
        //male connessioni precedentemente accettate continueranno ad essere attive
        try 
        {
            server.close();
        } 
        catch (IOException ex) 
        {
            System.out.println("Impossibile chiudere il socket");
        }
       
    }
    
    public static void main(String[] args) 
    {
        Scanner tastiera=new Scanner(System.in);
        try 
        {
            TCPServerConcorrente server=new TCPServerConcorrente(7);
            Thread serverThred=new Thread(server);
            serverThred.start();
            tastiera.nextLine();
            serverThred.interrupt();
            serverThred.join();
            System.out.println("Server interrotto");
        } 
        catch (IOException ex) 
        {
             System.out.println("Errore di comunicazione");
        } 
        catch (InterruptedException ex) 
        {
            System.out.println("Impossibile interrompere il server");
        }
    }
    
}
